<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Handler_Settings extends Controller {

        protected $model, $post;
        
        public function before() {
            parent::before();
            $this->model = new Model_Account;
            $this->post = Validation::factory(Arr::map('trim', $_POST));
            if(!$this->request->is_ajax() || Auth::isLoggedIn())
                throw HTTP_Exception::factory (403, 'no access');            
        }

        public function action_changeLogin()
        {
            $success = true;
            $this->post->rule('login', 'alpha_dash')->rule('login', 'not_empty');
            if($success = $this->post->check())
            {
                if($this->model->isAccountExists($this->post->offsetGet('login'), ''))
                        $success = false;
            }
            $user = Auth::getData();
            if($success)
                $this->model->changeLogin($user['ID'], $this->post->offsetGet('login'));
            $this->response->body("{'success': '$success' }");
        }
        
        public function action_changePassword()
        {
            $success = true;
            $this->post
                ->rule('password', 'min_length', array(':value', 8))
                ->rule('confirm_password', 'matches', array(':validation', 'confirm_password', 'password'));
            $user = Auth::getData();
            $data = $this->model->getAccountInfoByID($user['ID'])->offsetGet(0);
            if($success = $this->model->getAccountInfoByLogin($data['Login'], sha1($this->post->offsetGet('old_password'))))
                $this->model->changePassword($user['ID'], sha1($this->post->offsetGet('password')));
            $this->response->body("{'success': '$success'}");            
        }
        
        public function action_changeEMail()
        {
                        
        }
        
        public function action_confirmNewEMail()
        {
            
        }
}